import URL from "./urls.json";
class GitAPI {
  constructor(accessToken, repo, user) {
    this.accessToken = accessToken;
    this.user = user;
    this.repo = repo;
  }

  request(url, user, repo, formatter) {
    const options = {
      method: "GET",
      // 'username': data.login,
      headers: {
        Accept: "application/vnd.github.v3+json",
        "user-agent": `${user}`,
        authorization: `token ${this.accessToken}`,
      },
    };

    const final_url = url.replace("{owner}", user).replace("{repo}", repo);
    return fetch(`https://api.github.com/${final_url}`, options).then(
      (response) => {
        if (formatter) {
          return formatter(response.json());
        } else {
          return response.json();
        }
      }
    );
  }

  get_weekly_commit(user, repo) {
    return this.request(
      URL.weekly_commit,
      user || this.user,
      repo || this.repo
    );
  }

  get_last_year_commit(user, repo) {
    return this.request(
      URL.last_year_commit,
      user || this.user,
      repo || this.repo
    );
  }
}

export default GitAPI;
